class
	CE_STRUCTURE_FIELD

create
	make,
	make_arrayfield,
	make_bitfield

feature {NONE}

	make (a_name: STRING_8)
		do
			name := a_name
		end

	make_arrayfield (a_name: STRING_8; a_dimensions: ARRAY [INTEGER_32])
		do
			make (a_name)
			dimensions := a_dimensions
		end

	make_bitfield (a_name: STRING_8)
		do
			make (a_name)
			c_offset := -1
			is_bitfield := True
		end

feature {ANY}

	name: STRING_8 assign set_name

	ce_type: INTEGER_32 assign set_ce_type

	eif_type: INTEGER_32 assign set_eif_type

	internal_index: INTEGER_32 assign set_internal_index

	c_offset: INTEGER_32 assign set_c_offset

	alignment: INTEGER_32 assign set_alignment

feature {ANY}

	set_name (a_name: STRING_8)
		do
			name := a_name
		end

	set_ce_type (a_ce_type: INTEGER_32)
		do
			ce_type := a_ce_type
		end

	set_eif_type (a_eif_type: INTEGER_32)
		do
			eif_type := a_eif_type
		end

	set_internal_index (a_internal_index: INTEGER_32)
		do
			internal_index := a_internal_index
		end

	set_c_offset (a_c_offset: INTEGER_32)
		require
			not is_bitfield
		do
			c_offset := a_c_offset
		end

	set_alignment (a_alignment: INTEGER_32)
		do
			alignment := a_alignment
		end

feature {ANY}

	is_arrayfield: BOOLEAN
		do
			Result := dimensions /= Void
		end

	dimensions: detachable ARRAY [INTEGER_32]

feature {ANY}

	is_bitfield: BOOLEAN

invariant
	name /= Void and then not name.is_empty
	not (is_arrayfield and is_bitfield)
	is_bitfield implies c_offset = -1

end
