class
	CE_VA_LIST

create
	default_create, -- dummy; CE_STATIC initialization
	make,
	make_shared,
	make_shared_indirect

feature {NONE}

	make (a_args: TUPLE; a_routine_info: ROUTINE [ANY, TUPLE])
		local
			l_va_start_index: INTEGER_32
		do
			l_va_start_index := a_routine_info.empty_operands.generating_type.generic_parameter_type (1).generic_parameter_count + 1
			if l_va_start_index <= a_args.count and then attached {CE_VA_LIST} a_args.item (l_va_start_index) as tmp then
				-- When external code calls a "vararg" Eiffel routine, the varargs are already
				-- put into a CE_VA_LIST and are accessible through `shared_c_pointer'.
				copy (tmp)
			else
				args := a_args
				va_start_index := l_va_start_index
				index := va_start_index
			end
		end

	make_shared (a_c_pointer: POINTER)
		do
			direct_c_pointer := a_c_pointer
		end

	make_shared_indirect (a_c_pointer: POINTER)
		do
			direct_c_pointer := (create {MANAGED_POINTER}.share_from_pointer (a_c_pointer, {PLATFORM}.Pointer_bytes)).read_pointer (0)
			indirect_c_pointer := a_c_pointer
		end

feature {ANY} -- non-shared data

	args: detachable TUPLE

	va_start_index, index: INTEGER_32

feature {CE_VA_LIST} -- shared data

	direct_c_pointer, indirect_c_pointer: POINTER

feature {ANY}

	integer_32_item: INTEGER_32
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Integer_32_code then
					Result := tmp_args.integer_32_item (index)
				when {TUPLE}.Natural_32_code then
					Result := tmp_args.natural_32_item (index).to_integer_32
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Integer_32_bytes)).read_integer_32 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Integer_32_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	integer_64_item: INTEGER_64
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Integer_64_code then
					Result := tmp_args.integer_64_item (index)
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Integer_64_bytes)).read_integer_64 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Integer_64_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	natural_32_item: NATURAL_32
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Integer_32_code then
					Result := tmp_args.integer_32_item (index).to_natural_32
				when {TUPLE}.Natural_32_code then
					Result := tmp_args.natural_32_item (index)
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Natural_32_bytes)).read_natural_32 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Natural_32_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	natural_64_item: NATURAL_64
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Integer_64_code then
					Result := tmp_args.integer_64_item (index).to_natural_64
				when {TUPLE}.Natural_64_code then
					Result := tmp_args.natural_64_item (index)
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Natural_64_bytes)).read_natural_64 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Natural_64_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	real_32_item: REAL_32
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Real_32_code then
					Result := tmp_args.real_32_item (index)
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Real_32_bytes)).read_real_32 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Real_32_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	real_64_item: REAL_64
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Real_64_code then
					Result := tmp_args.real_64_item (index)
				end
				index := index + 1
			else
				Result := (create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Real_64_bytes)).read_real_64 (0)
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Real_64_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	real_96_item: REAL_96
		do
			if attached args as tmp_args then
				inspect
					tmp_args.item_code (index)
				when {TUPLE}.Reference_code then
					check attached {REAL_96}tmp_args.reference_item (index) as tmp then
						Result := tmp
					end
				end
				index := index + 1
			else
				Result.c_pointer.memory_copy (direct_c_pointer, {CE_UTILITIES}.Real_96_bytes)
				direct_c_pointer := direct_c_pointer + {CE_UTILITIES}.Real_96_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		end

	ce_class_item (a_type: TYPE [detachable CE_CLASS]): CE_CLASS
--		local
--			l_old_state: BOOLEAN
		do
			check
				attached args as tmp_args and then
				attached {CE_CLASS} tmp_args.item (index) as tmp
			then
				Result := tmp
				index := index + 1
--			else
--				l_old_state := {ISE_RUNTIME}.check_assert (False)
--				Result ?= (create {INTERNAL}).new_instance_of (a_type.type_id)
--				Result.make_shared (shared_c_pointer)
--				l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
			end
		end

	pointer_item: CE_POINTER [ANY]
		do
			if attached args as tmp_args then
				inspect tmp_args.item_code (index)
				when {TUPLE}.Integer_32_code then
					create {CE_VOID_POINTER} Result.make_shared (default_pointer + tmp_args.integer_32_item (index))
				when {TUPLE}.Reference_code then
					check attached {CE_POINTER [ANY]} tmp_args.item (index) as tmp then
						Result := tmp
					end
				end
				index := index + 1
			else
				create {CE_VOID_POINTER} Result.make_shared ((create {MANAGED_POINTER}.share_from_pointer (direct_c_pointer, {PLATFORM}.Pointer_bytes)).read_pointer (0))
				direct_c_pointer := direct_c_pointer + {PLATFORM}.Pointer_bytes
				if indirect_c_pointer /= default_pointer then
					(create {MANAGED_POINTER}.share_from_pointer (indirect_c_pointer, {PLATFORM}.Pointer_bytes)).put_pointer (direct_c_pointer, 0)
				end
			end
		ensure
			Result /= Void
		end

feature {ANY}

	c_pointer: POINTER
		do
			if args /= Void then
				Result := va_list + byte_offset[index - va_start_index + 1]
			else
				Result := direct_c_pointer
			end
		end

feature {NONE} -- c_pointer helpers

	va_list: POINTER
		require
			args /= Void
		local
			l_mp: MANAGED_POINTER
			l_arg_index: INTEGER_32
			l_pos: INTEGER_32
			l_obj: detachable ANY
		once ("OBJECT")
			check attached args as tmp_args then
				if byte_offset[byte_offset.count] > 0 then
					Result := Result.memory_alloc (byte_offset[byte_offset.count])
					from
						create l_mp.share_from_pointer (Result, byte_offset[byte_offset.count])
						l_arg_index := va_start_index
					until
						l_arg_index > tmp_args.count
					loop
						l_pos := byte_offset[l_arg_index - va_start_index + 1]
						inspect
							tmp_args.item_code (l_arg_index)
						when {TUPLE}.Integer_8_code  then l_mp.put_integer_8  (tmp_args.integer_8_item  (l_arg_index), l_pos)
						when {TUPLE}.Integer_16_code then l_mp.put_integer_16 (tmp_args.integer_16_item (l_arg_index), l_pos)
						when {TUPLE}.Integer_32_code then l_mp.put_integer_32 (tmp_args.integer_32_item (l_arg_index), l_pos)
						when {TUPLE}.Integer_64_code then l_mp.put_integer_64 (tmp_args.integer_64_item (l_arg_index), l_pos)
						when {TUPLE}.Natural_8_code  then l_mp.put_natural_8  (tmp_args.natural_8_item  (l_arg_index), l_pos)
						when {TUPLE}.Natural_16_code then l_mp.put_natural_16 (tmp_args.natural_16_item (l_arg_index), l_pos)
						when {TUPLE}.Natural_32_code then l_mp.put_natural_32 (tmp_args.natural_32_item (l_arg_index), l_pos)
						when {TUPLE}.Natural_64_code then l_mp.put_natural_64 (tmp_args.natural_64_item (l_arg_index), l_pos)
						when {TUPLE}.Real_32_code    then l_mp.put_real_32    (tmp_args.real_32_item    (l_arg_index), l_pos)
						when {TUPLE}.Real_64_code    then l_mp.put_real_64    (tmp_args.real_64_item    (l_arg_index), l_pos)
						when {TUPLE}.reference_code then
							l_obj := tmp_args.item (l_arg_index)
							if attached {CE_POINTER [ANY]} l_obj as tmp then
								l_mp.put_pointer (tmp.c_pointer, l_pos)
							elseif attached {REAL_96} l_obj as tmp then
								(l_mp.item + l_pos).memory_copy (tmp.c_pointer, {CE_UTILITIES}.Real_96_bytes)
							else
								(create {EXCEPTIONS}).raise ("CE_VA_LIST.va_list")
							end
						end
						l_arg_index := l_arg_index + 1
					end
				end
			end
		end

	byte_offset: ARRAY [INTEGER]
		require
			args /= Void
		local
			l_arg_index: INTEGER_32
			l_array_index: INTEGER_32
			l_obj: detachable ANY
		once ("OBJECT")
			check attached args as tmp_args then
				from
					create Result.make_filled (0, 1, tmp_args.count - va_start_index + 2)
					l_arg_index := va_start_index
					l_array_index := 2
				until
					l_arg_index > tmp_args.count
				loop
					inspect
						tmp_args.item_code (l_arg_index)
					when {TUPLE}.Integer_8_code then  Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Integer_8_bytes
					when {TUPLE}.Integer_16_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Integer_16_bytes
					when {TUPLE}.Integer_32_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Integer_32_bytes
					when {TUPLE}.Integer_64_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Integer_64_bytes
					when {TUPLE}.Natural_8_code then  Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Natural_8_bytes
					when {TUPLE}.Natural_16_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Natural_16_bytes
					when {TUPLE}.Natural_32_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Natural_32_bytes
					when {TUPLE}.Natural_64_code then Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Natural_64_bytes
					when {TUPLE}.Real_32_code then    Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Real_32_bytes
					when {TUPLE}.Real_64_code then    Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Real_64_bytes
					when {TUPLE}.reference_code then
						l_obj := tmp_args.item (l_arg_index)
						if attached {CE_POINTER [ANY]} l_obj as tmp then
							Result[l_array_index] := Result[l_array_index - 1] + {PLATFORM}.Pointer_bytes
						elseif attached {REAL_96} l_obj as tmp then
							Result[l_array_index] := Result[l_array_index - 1] + {CE_UTILITIES}.Real_96_bytes
						else
							(create {EXCEPTIONS}).raise ("CE_VA_LIST.byte_offset")
						end
					end
					l_arg_index := l_arg_index + 1
					l_array_index := l_array_index + 1
				end
			end
		end

end
