class
	CE_CLASS_POINTER [G -> CE_CLASS]

inherit
	CE_POINTER [G]
		redefine
			make,
			make_shared,
			make_shared_with_count,
			make_cast
		end
	INTERNAL
		rename
			is_equal as is_equal_from_any
		undefine
			is_equal_from_any
		end

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {NONE}

	make
		do
			init_element_info
			Precursor
		end

	make_shared (a_c_pointer: POINTER)
		do
			init_element_info
			Precursor (a_c_pointer)
		end

	make_shared_with_count (a_c_pointer: POINTER; a_count: INTEGER_32)
		do
			init_element_info
			Precursor (a_c_pointer, a_count)
		end

	make_cast (a_other: CE_POINTER [ANY])
		do
			init_element_info
			Precursor (a_other)
		end

feature {ANY}

	element_size: INTEGER_32

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): G assign set_i_th
		local
			l_old_state: BOOLEAN
		do
--			if a_index + 1 > element_cache.count then
--				element_cache := element_cache.aliased_resized_area_with_default (
--						({G}).default,
--						(2 * element_cache.count).max (a_index + 1)
--					)
--			end
--			Result := element_cache[a_index]
--			if Result = Void then
				l_old_state := {ISE_RUNTIME}.check_assert (False)
				check attached {G} new_instance_of (element_type_id) as tmp_result then
					tmp_result.make_shared (c_pointer + (a_index * element_size))
					Result := tmp_result
				end
				l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
--				element_cache[a_index] := Result
--			end
		end

	set_i_th (a_item: G; a_index: INTEGER_32)
		do
			(c_pointer + (a_index * element_size)).memory_copy (a_item.c_pointer, element_size)
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_CLASS_POINTER [G]
		do
			if byte_count = {INTEGER_32}.Max_value then
				create Result.make_shared (c_pointer + (i * element_size))
			else
				create Result.make_shared_with_count (c_pointer + (i * element_size), count - i)
			end
		end

feature {NONE}

--	element_cache: SPECIAL [G]

	element_info_cache: SPECIAL [INTEGER_32]
		once ("PROCESS")
			create Result.make_filled (-1, 10_000)
		end

	init_element_info
		local
			l_old_state: BOOLEAN
		do
--			create element_cache.make_filled (({G}).default, 16)
			element_type_id := ({G}).type_id
			element_size := element_info_cache[element_type_id]
			if element_size = -1 then
				l_old_state := {ISE_RUNTIME}.check_assert (False)
				check attached {CE_CLASS} new_instance_of (element_type_id) as tmp_class then
					element_size := tmp_class.structure_size
				end
				l_old_state := {ISE_RUNTIME}.check_assert (l_old_state)
				element_info_cache[element_type_id] := element_size
			end
		end

	element_type_id: INTEGER_32

end
