class
	CE_REAL_32_POINTER

inherit
	CE_POINTER [REAL_32]

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {ANY}

	element_size: INTEGER_32
		do
			Result := {PLATFORM}.Real_32_bytes
		end

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): REAL_32 assign set_i_th
		do
			Result := c_read (c_pointer, a_index * {PLATFORM}.Real_32_bytes)
		end

	set_i_th (a_item: REAL_32; a_index: INTEGER_32)
		do
			c_write (c_pointer, a_index * {PLATFORM}.Real_32_bytes, a_item)
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_REAL_32_POINTER
		do
			if byte_count = {INTEGER_32}.Max_value then
				create Result.make_shared (c_pointer + (i * {PLATFORM}.Real_32_bytes))
			else
				create Result.make_shared_with_count (c_pointer + (i * {PLATFORM}.Real_32_bytes), count - i)
			end
		end

feature {ANY} -- c utilities

	c_read (a_c_pointer: POINTER; a_offset: INTEGER_32): REAL_32
		external
			"C inline"
		alias
			"return *(EIF_REAL_32 *)(((char *)$a_c_pointer) + $a_offset);"
		end

	c_write (a_c_pointer: POINTER; a_offset: INTEGER_32; a_value: REAL_32)
		external
			"C inline"
		alias
			"*(EIF_REAL_32 *)(((char *)$a_c_pointer) + $a_offset) = $a_value;"
		end

end
