class
	CE_REAL_96_POINTER

inherit
	CE_POINTER [REAL_96]

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {ANY}

	element_size: INTEGER_32
		do
			Result := {CE_UTILITIES}.Real_96_bytes
		end

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): REAL_96 assign set_i_th
		do
			Result.c_pointer.memory_copy (c_pointer + (a_index * {CE_UTILITIES}.Real_96_bytes), {CE_UTILITIES}.Real_96_bytes)
		end

	set_i_th (a_item: REAL_96; a_index: INTEGER_32)
		do
			(c_pointer + (a_index * {CE_UTILITIES}.Real_96_bytes)).memory_copy (a_item.c_pointer, {CE_UTILITIES}.Real_96_bytes)
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_REAL_96_POINTER
		do
			if byte_count = {INTEGER_32}.Max_value then
				create Result.make_shared (c_pointer + (i * {CE_UTILITIES}.Real_96_bytes))
			else
				create Result.make_shared_with_count (c_pointer + (i * {CE_UTILITIES}.Real_96_bytes), count - i)
			end
		end

end
