expanded class
	REAL_96

inherit
	COMPARABLE
		redefine
			default_create,
			is_equal,
			out
		end

feature {NONE}

	default_create
		do
			create data.make ({CE_UTILITIES}.Real_96_bytes)
		end

feature {REAL_96}

	data: MANAGED_POINTER

feature {ANY}

	c_pointer: POINTER
		do
			Result := data.item
		end

feature {ANY}

	plus alias "+" (a_other: REAL_96): REAL_96
		do
			c_plus (Result.data.item, data.item, a_other.data.item)
		end

	minus alias "-" (a_other: REAL_96): REAL_96
		do
			c_minus (Result.data.item, data.item, a_other.data.item)
		end

	product alias "*" (a_other: REAL_96): REAL_96
		do
			c_product (Result.data.item, data.item, a_other.data.item)
		end

	quotient alias "/" (a_other: REAL_96): REAL_96
		do
			c_quotient (Result.data.item, data.item, a_other.data.item)
		end

	identity alias "+": REAL_96
		do
			c_identity (Result.data.item, data.item)
		end

	opposite alias "-": REAL_96
		do
			c_opposite (Result.data.item, data.item)
		end

	is_equal (a_other: REAL_96): BOOLEAN
		do
			Result := c_is_equal (data.item, a_other.data.item)
		end

	is_less alias "<" (a_other: REAL_96): BOOLEAN
		do
			Result := c_is_less (data.item, a_other.data.item)
		end

	out: STRING_8
		do
			Result := c_out (data.item)
		end

feature {ANY}

	truncated_to_integer: INTEGER_32
		do
			Result := truncated_to_real_64.truncated_to_integer
		end

	truncated_to_integer_64: INTEGER_64
		do
			Result := truncated_to_real_64.truncated_to_integer_64
		end

	truncated_to_real_32: REAL_32
		do
			Result := truncated_to_real_64.truncated_to_real
		end

	truncated_to_real_64: REAL_64
		do
			Result := c_truncated_to_real_64 (data.item)
		end

feature {ANY}

	set_from_integer_8 (a_value: INTEGER_8)
		do
			c_set_from_integer_8 (data.item, a_value)
		end

	set_from_integer_16 (a_value: INTEGER_16)
		do
			c_set_from_integer_16 (data.item, a_value)
		end

	set_from_integer_32 (a_value: INTEGER_32)
		do
			c_set_from_integer_32 (data.item, a_value)
		end

	set_from_integer_64 (a_value: INTEGER_64)
		do
			c_set_from_integer_64 (data.item, a_value)
		end

	set_from_natural_8 (a_value: NATURAL_8)
		do
			c_set_from_natural_8 (data.item, a_value)
		end

	set_from_natural_16 (a_value: NATURAL_16)
		do
			c_set_from_natural_16 (data.item, a_value)
		end

	set_from_natural_32 (a_value: NATURAL_32)
		do
			c_set_from_natural_32 (data.item, a_value)
		end

	set_from_natural_64 (a_value: NATURAL_64)
		do
			c_set_from_natural_64 (data.item, a_value)
		end

	set_from_real_32 (a_value: REAL_32)
		do
			c_set_from_real_32 (data.item, a_value)
		end

	set_from_real_64 (a_value: REAL_64)
		do
			c_set_from_real_64 (data.item, a_value)
		end

feature {NONE}

	c_plus (a_res_p, a_cur_p, a_other_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = *(long double *)$a_cur_p + *(long double *)$a_other_p;"
		end

	c_minus (a_res_p, a_cur_p, a_other_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = *(long double *)$a_cur_p - *(long double *)$a_other_p;"
		end

	c_product (a_res_p, a_cur_p, a_other_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = *(long double *)$a_cur_p * *(long double *)$a_other_p;"
		end

	c_quotient (a_res_p, a_cur_p, a_other_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = *(long double *)$a_cur_p / *(long double *)$a_other_p;"
		end

	c_identity (a_res_p, a_cur_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = +*(long double *)$a_cur_p;"
		end

	c_opposite (a_res_p, a_cur_p: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res_p = -*(long double *)$a_cur_p;"
		end

	c_is_equal (a_cur_p, a_other_p: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return *(long double *)$a_cur_p == *(long double *)$a_other_p;"
		end

	c_is_less (a_cur_p, a_other_p: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return *(long double *)$a_cur_p < *(long double *)$a_other_p;"
		end

	c_out (a_cur_p: POINTER): STRING_8
		external
			"C inline use <stdio.h>"
		alias
			"[
				char buf[100];
				snprintf(buf, 100, "%Lf", *(long double *)$a_cur_p);
				return eif_string(buf);
			]"
		end

feature {NONE}

	c_truncated_to_real_64 (a_cur_p: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)*(long double *)$a_cur_p;"
		end

feature {NONE}

	c_set_from_integer_8 (a_cur_p: POINTER; a_value: INTEGER_8)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (signed char)$a_value;"
		end

	c_set_from_integer_16 (a_cur_p: POINTER; a_value: INTEGER_16)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (signed short)$a_value;"
		end

	c_set_from_integer_32 (a_cur_p: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (signed int)$a_value;"
		end

	c_set_from_integer_64 (a_cur_p: POINTER; a_value: INTEGER_64)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (signed long long)$a_value;"
		end

	c_set_from_natural_8 (a_cur_p: POINTER; a_value: NATURAL_8)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (unsigned char)$a_value;"
		end

	c_set_from_natural_16 (a_cur_p: POINTER; a_value: NATURAL_16)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (unsigned short)$a_value;"
		end

	c_set_from_natural_32 (a_cur_p: POINTER; a_value: NATURAL_32)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (unsigned int)$a_value;"
		end

	c_set_from_natural_64 (a_cur_p: POINTER; a_value: NATURAL_64)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (unsigned long long)$a_value;"
		end

	c_set_from_real_32 (a_cur_p: POINTER; a_value: REAL_32)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (float)$a_value;"
		end

	c_set_from_real_64 (a_cur_p: POINTER; a_value: REAL_64)
		external
			"C inline"
		alias
			"*(long double *)$a_cur_p = (double)$a_value;"
		end

end
